<template>
  <div class="w-full h-full bg-white p-4">
    <p class="font-bold text-lg leading-10 border-b-2">客户邮箱管理</p>
    <el-form class="pt-4" :inline="true" :model="formState">
      <el-form-item label="客户">
        <el-input v-model="formState.customerName" placeholder="" readonly>
          <template #append>
            <el-button :icon="MoreFilled" @click="openModal('search')"></el-button>
          </template>
        </el-input>
      </el-form-item>
      <el-form-item label="邮箱地址">
        <el-input v-model="formState.email" placeholder="" />
      </el-form-item>

      <el-form-item>
        <el-button type="default" @click="onReset">重置</el-button>
        <el-button type="primary" @click="onQuery">查询</el-button>
      </el-form-item>
    </el-form>

    <div class="">
      <vxe-toolbar>
        <template #buttons>
          <!-- <vxe-button @click="allAlign = 'left'">居左</vxe-button> -->
          <el-button type="primary" @click="showEdit = true">新增</el-button>
          <el-button type="danger" @click="removeRows">删除</el-button>
        </template>
      </vxe-toolbar>
      <vxe-table
        ref="xTable"
        size="small"
        min-height="460"
        border
        :loading="loading"
        :data="tableData"
      >
        <vxe-column type="checkbox" width="50"></vxe-column>
        <vxe-column field="customerId_dictText" title="客户名称" width="200"></vxe-column>
        <vxe-column field="email" title="邮箱地址"></vxe-column>

        <vxe-column field="action" title="操作" width="100">
          <template #default="{ row }">
            <el-button type="primary" text size="small" @click="editRow(row)">修改</el-button>
          </template>
        </vxe-column>
      </vxe-table>

      <vxe-pager
        size="small"
        background
        v-model:current-page="formState.currentPage"
        v-model:page-size="formState.pageSize"
        :total="formState.total"
        @page-change="onQuery"
        :layouts="['PrevPage', 'JumpNumber', 'NextPage', 'Sizes', 'FullJump', 'Total']"
      >
      </vxe-pager>
    </div>

    <vxe-modal :z-index="1005" v-model="showEdit" title="编辑&保存" destroy-on-close esc-closable @hide="onHide">
      <template #default>
        <el-form ref="formRef" label-width="90px" :model="formEdit" :rules="formRules">
          <el-form-item label="客户" prop="customerId_dictText">
            <el-input v-model="formEdit.customerId_dictText" disabled>
              <template #append>
                <el-button :icon="MoreFilled" @click="openModal('edit')"></el-button>
              </template>
            </el-input>
          </el-form-item>
          <el-form-item label="邮箱地址" prop="email">
            <el-input v-model="formEdit.email"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="onSubmit" :loading="saveLoading">提交</el-button>
            <el-button @click="showEdit = false">取消</el-button>
          </el-form-item>
        </el-form>
      </template>
    </vxe-modal>

    <CustomerModal v-model:visible="visibleModal" @confirm="confirmCustomer" />
  </div>
</template>

<script lang="ts" setup>
import { onMounted, reactive, ref } from 'vue'
import {
  getCustomerEmailList,
  saveCustomerEmail,
  deleteCustomerEmails,
  modifyCustomerEmail
} from '@/api/order'
import { ElMessage } from 'element-plus'
import type { VxeTableInstance } from 'vxe-table'

import { MoreFilled } from '@element-plus/icons-vue'
import CustomerModal from '@/components/CustomerModal/CustomerModal.vue'
import { useRoute } from 'vue-router'

const route = useRoute()
const visibleModal = ref(false)
const loading = ref(false)
const saveLoading = ref(false)
const showEdit = ref(false)
const formState = reactive({
  customerName: '',
  email: '',
  customerId: '',
  currentPage: 1,
  pageSize: 10,
  total: 0,
})

const modalType = ref('')
const formRef = ref()
const xTable = ref<VxeTableInstance>()
const formRules = reactive({
  email: [
    { type: 'email', message: '请输入正确的邮箱地址', trigger: 'change' },
    { required: true, message: '请输入邮箱地址', trigger: 'change' }
  ],
  customerId_dictText: [{ required: true, message: '请选择邮箱客户', trigger: 'change' }]
})
const formEdit = reactive<Record<string, any>>({
  customerId_dictText: '',
  customerId: '',
  email: ''
})

const tableData = ref([])
const onHide = () => {
  // 重置表单
  Object.assign(formEdit, {
    customerId_dictText: '',
    customerId: '',
    email: ''
  })
}

const onReset = () => {
  Object.assign(formState, {
    customerName: '',
    email: '',
    customerId: ''
  })
}

const openModal = (type: string) => {
  visibleModal.value = true
  modalType.value = type
}
const editRow = (row) => {
  Object.assign(formEdit, row)
  showEdit.value = true
}

const removeRows = async () => {
  const list = xTable.value?.getCheckboxRecords()
  if (list?.length) {
    const ids = list.map((item) => item.customerEmailId).join(',')
    await deleteCustomerEmails(ids)
    ElMessage.success('删除成功！')
    onQuery()
  }
}

// 表单提交
const onSubmit = async () => {
  await formRef.value.validate()
  saveLoading.value = true
  try {
    formEdit?.customerEmailId
      ? await modifyCustomerEmail(formEdit)
      : await saveCustomerEmail(formEdit)
    ElMessage.success('操作成功！')
    showEdit.value = false
    onQuery()
  } catch {}
  saveLoading.value = false
}
const confirmCustomer = (list: any) => {
  const [item] = list
  if (!item) return
  if (modalType.value === 'search') {
    formState.customerId = item.customerId
    formState.customerName = item.customerName
  } else {
    formEdit.customerId = item.customerId
    formEdit.customerId_dictText = item.customerName
  }
}

const onQuery = async () => {
  loading.value = true
  try {
    const { data } = await getCustomerEmailList(formState)
    tableData.value = data.result.records
    formState.total = +data.result.total
  } catch {}
  loading.value = false
}

onMounted(() => {
  Object.assign(formState, route.query)
  onQuery()
})
</script>
<style lang="scss" scoped></style>
